This is a solid component?!

There is a missing face leaving a hole, but SketchUP says it is a solid!

How about uploading the SKP file so we can check it out?

Done.
Leg_01.skp (57.5 KB)

I think you’ve created an interesting conundrum for the Solid Inspector and for SketchUp. There is indeed a hole there.

Adding a face in there creates an issue, too. On the other hand, do you really want the hole coming down through the corner of the post?

I recall reading that there are some known corner-cases that can fool the analysis of solids. Perhaps @tt_su or @TIG could comment further.

That is how it was manufactured. Seems the top plate is used with other legs, where it is centered and the whole 4 holes are used. Actually, it is fastened with a screw to the body.

Could the holes really be faces, just hidden?

It’s an interesting case.
No hidden faces and nothing on off-layers.
The reason thomthom’s SolidInspector² AND my SolidSolver both fail to spot the hole, is that SketchUp itself reports the grouped geometry as a manifold solid - so no further action is anticipated/done.
Which is clearly incorrect, because the hole is bounded by some edges which only support one face each: and of course the definition of a manifold solid is that every edge supports exactly two faces !
Adding a face to the hole then stops SketchUp reporting it as Solid !
SolidSolver² considers the face just added as incorrectly oriented and reverses it ! That’s a limitation of the algorithm used to find reversed faces.
image
The image above shows the top part [in Xray mode] and faces 1, 2 and 3 are taken as using the blue colored edge***. This is weird since face-1 only touches that edge at a vertex !!
I found this out by grouping it, selecting it, and using a simple Ruby snippet in the Console:

m=Sketchup.active_model;ss=m.selection;g=ss[0];ss.clear;g.entities.grep(Sketchup::Edge).each{|e|if e.faces.length!=2;ss.add([e]+e.faces);puts;break;end };puts

BUT there is a straightforward fix…

Add the missing face and PushPull it downwards by 0.1mm.
Now it reports as a Solid.
In the image below the highlighted face shows it very slightly lower and the yellow dots show the two tiny 0.1mm long vertical edges which get made.
If this is to be 3d-printed then such a small dimension will be all but invisible.

Thanks, TIG - always learn something new.

The model geometry is for some reason corrupted. If you double click the lower face (select it’s bouning edges) you end up with this selection. For some reason SketchUp hasn’t merged 2 of the inner loops (holes) into one.

The Ruby API reports all edges bind exactly two faces (prior to me removing some to get a better view), which explains why solid inspector regards it a solid.

Sketchup.active_model.entities.grep(Sketchup::Edge).map { |e| e.faces.size }.uniq
# => [2]

You can also check how many loops SketchUp regards the face in question to have. The expected result would be 5, one outer and 4 inner, but it reports 6.

Sketchup.active_model.selection.first.loops.size
# => 6

Cutting and pasting in place, as well as redrawing edges to renew faces, often fixes this kind of issues.

1 Like

Maybe off topic, but I’d probably model this as two groups as it appears to be two distinct parts joined together.

That’s the crux of it. I’m not sure how the model got into that state. But SU doesn’t even detect an issue when using Fix Problems.

Any insight to how this geometry was created? What native tools? Extensions? Imported?

Native SU tools. Two components joined together with SU “Solid Union”.

Do you still have the original components? If we can reproduce it it would help greatly.

1 Like

Short video how i made it - Fake_Solid.zip (2.2 MB)

1 Like

Logged as SKOR-11265